#include "website.ch"

STATIC scSession  := ""
STATIC scCmd := ""
STATIC scQuery := ""
STATIC soIni


//
function MAIN( cCmd, cRecno )  // --> CMD line params. passed by server
LOCAL oCgi, aCmd, cQuery

SET DATE BRITISH

IF cCmd == NIL
   cCmd := ""
ENDIF

IF "%" $ cCmd
   cCmd := DecodeURL( cCmd )
   aCmd := listAsArray( cCmd, " ")
   cCmd := aCmd[1]
   IF LEN( aCmd ) > 1
      cRecno := aCmd[2]
   ENDIF
ENDIF

scCmd := cCmd


IF "POST" $ UPPER(GETENV("REQUEST_METHOD"))
      oCgi   := oCGI():New()
      cQuery := UPPER(oCgi:query_String)          // just in case...
ELSE
      oCgi   := oCGI():New()
      cQuery := UPPER(GETENV("QUERY_STRING"))
ENDIF

scQuery := cQuery

soIni := oIni():New("website.ini")
soIni:read()
soIni:close()


//
//  simple redirection based on command line arguments.
//  Each of the following routines produces stand alone HTML/CGI output
//
//

IF "LIST" $ cCmd
    funclist( )
ELSEIF "REDIRECT" $ cCmd
    Redirect(oCgi,cRecno)
ELSEIF "MAINPAGE" $ cCmd
 MainPage()
ELSE
    BlankPage()
ENDIF

RETURN  nil

PROCEDURE Redirect(ocgi,crecno)
LOCAL oHtm
DEFINE CGI ;
       TITLE "Redirection" ;
       JAVACODE "location.href='"+crecno +"';" ;
       BGCOLOR "white" ;
       OF oHtm
oHtm:CGIClose()
RETURN
         

procedure funclist( oCgi )
LOCAL oHtm,x
Local aList:= readlist()
DEFINE CGI TITLE 'Harbour function task list for File Api,Extend Api,Gt Api,Error Api' bgcolor "white" of oHtm
SET FONT "" of ohtm
DEFINE TABLE BGCOLOR "#66ccff" border  0 WIDTH '600' CENTER of ohtm
ohtm:qqout("<TBODY>")
ohtm:newTableRow()
DEFINE CELL   height 1 width '90' aling middle center of ohtm
//Start font COLOR "#ffff80" OF ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org" ;
      IMAGE  "../images/hrbbtn.gif" ;
      border 0 height '43'  width '99' Target "_top"  OF oHtm
//End font of ohtm 
ohtm:EndTableCell()
DEFINE CELL HEIGHT 1 WIDTH  '474' top OF OHTM
DEFINE TABLE BORDER 2 BGCOLOR "#66ccff" ;
          COLORDARK "#66ccff"       ;
          COLORLIGHT "#66ccff"      ;          
          BORDERCOLOR "#ffffff" of ohtm                        
ohtm:qqout("<TBODY>")
ohtm:newTableRow()
DEFINE CELL HEIGHT 1 WIDTH '95' ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
//start font color "#000000" size 2 of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/" ;
      Text "Home" FONTCOLOR "#000000#" SIZE 2 STYLE "TEXT-DECORATION: none"  BOLD of ohtm
ohtm:endtablecell()
DEFINE CELL width "71" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm" ;
    TEXT "Download" FONTCOLOR "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
    ohtm:EndTableCell()
DEFINE CELL width "85" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/links.htm" ;
    TEXT "Links" FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM
ohtm:EndTableCell()
DEFINE CELL width "84" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/mailinglist.htm" ;
    TEXT 'Mailing List' FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endTableCell()
DEFINE CELL width "123" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?http://www.hagbard.demon.co.uk/harbour/harbour.html" ;
    TEXT 'FAQ' FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endtablecell()
ohtm:EndTableRow()
oHtm:NewTableRow()
DEFINE CELL width "84" height 15 ;
          COLORDARK "#808080"       ;
          COLORLIGHT "#ffffff"      ;
           nowrap ALING middle of ohtm
SAY "Function List" ;
     TYPE '<B>'  color "#000000" STYLE "text-decoration: none" size  2  OF OHTM
ohtm:Endtablecell()
DEFINE CELL width "71" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/crew.htm";
    TEXT  'Crew List' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM
ohtm:endTableCell()

DEFINE CELL width "85" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/art.htm";
    TEXT 'Harbour Art' FONTcolor "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
ohtm:endTableCell()

DEFINE CELL width "84" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/3rdparty.htm";
    TEXT '3rd Party' FONTcolor "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
ohtm:endTableCell()
DEFINE CELL width "123" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/hbdoc";
    TEXT 'Documentation' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endTableCell()

ohtm:endtablerow();ohtm:qqout("</TBODY>");ohtm:endTable();ohtm:EndTableRow();ohtm:qqout("</TBODY>");ohtm:endtable()



ohtm:Paragraph()
SAY "Below is a list of all Harbour "+;
"functions in the RTL and their current state. This list is "+;
"updated as changes are made to the library. This list is based on "+;
"Clipper 5.2. The legend is as follows:" SIZE 2 OF OHTM
ohtm:Paragraph(.F.)
ohtm:Paragraph()
SAY  "<strong>Ready</strong><br>" +;
"No more work needed on this function"  size 2 of ohtm
ohtm:Paragraph(.F.)
ohtm:Paragraph()
SAY "<strong>Started</strong><br>" +;
"This function needs some work but will provide basic " +;
"functionality and can be used for testing." size 2 of ohtm
ohtm:Paragraph(.F.)
ohtm:Paragraph()
SAY "<strong>Not Started</strong><br>"+;
"This function has yet to be written"  size 2 of ohtm
ohtm:Paragraph(.F.)
ohtm:setcenter(.t.)
DEFINE TABLE  BGCOLOR CLR_WHITE border 1 width "500"  CELLPADDING 2 CELLSPACING 1 CENTER        of oHtm
oHtm:newTableRow()
DEFINE CELL color "#3000FF" WIDTH "50%"  SIZE 2  FONTCOLOR  "#ffff00"  ROWSPAN 2 of oHtm
oHtm:qqout('<center><b>Function</b>')
oHtm:EndTableCell()
DEFINE CELL color "#3000FF" WIDTH "50%"  SIZE 2  FONTCOLOR  "#ffff00"  COLSPAN 3  of oHtm
oHtm:qqout('<center><b>Status</b>')
oHtm:EndTableCell()
oHtm:EndTableRow()
oHtm:newTableRow()  
DEFINE CELL  color "#3000FF" WIDTH "16%"  SIZE 2  FONTCOLOR  "#ffff00"    of oHtm     
oHtm:qqout("<center><b>Ready</b>");oHtm:EndTableCell() 

DEFINE CELL  color "#3000FF" WIDTH "16%"  SIZE 2  FONTCOLOR  "#ffff00"     of oHtm     
oHtm:qqout("<center><b>Stated</b>");oHtm:EndTableCell()

DEFINE CELL  color "#3000FF" WIDTH "16%"  SIZE 2  FONTCOLOR  "#ffff00"     of oHtm     
oHtm:qqout("<center><b>Not Stated</b>");oHtm:EndTableCell() ; oHtm:EndTableRow()
for x:=1 to len(alist)
oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout(alist[x,1]);oHtm:EndTableCell()
if alist[x,2]=="R"
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()
elseif alist[x,2]=="S"
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

elseif alist[x,2]=="N"
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');;oHtm:EndTableCell();oHtm:EndTableRow()
else
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()
endif
next

oHtm:cgiClose()

return

function  Readlist()
local alist:={}
Local nPos
Local cBuffer:=''
Local cFunc
Local cStat:=" "
ft_fuse('funclist.txt')
do while !ft_FEOF()
cBuffer:=ltrim(rtrim(alltrim(FReadLn())))
cFunc:=substr(cBuffer,1,at(";",cbuffer)-1)
if empty(cFunc)
cFunc:=substr(cBuffer,at(";",cbuffer))
cStat :=" "
endif

cBuffer:=strtran(cBuffer,cfunc,"")
cBuffer:=strtran(cbuffer,chr(13),"")
cBuffer:=strtran(cbuffer,";","")


cStat:=cbuffer
aadd(alist,{cFunc,cStat})
FT_FSKIP()
 ENDDO
 FT_FUSE()
return alist

//
PROCEDURE BlankPage( oCgi )
//
LOCAL oHtm

DEFINE CGI ;
       BGIMAGE (COMMON_BGIMAGE) ;
       BGCOLOR (COMMON_BGCOLOR) ;
       TITLE "ACTION Error !!!" ;
       OF oHtm

oHtm:SetTextColor("black")
oHtm:Setcenter( .T. )

oHtm:WriteLN("")
oHtm:WriteLN("ERROR !!!")
oHtm:WriteLN("")
oHtm:WriteLN("Please specify an appropriate action...")

oHtm:cgiClose()

RETURN
function  MainPage(oCgi)
Local oHtm

DEFINE CGI TITLE 'Harbour, a free software Clipper compatible compiler.' bgcolor "white" CHARSET "iso-8859-1" of oHtm
set font  "" of ohtm
DEFINE TABLE BGCOLOR "#66ccff" border  0  height "155" WIDTH '600' CENTER of ohtm
ohtm:qqout("<TBODY>")
ohtm:newTableRow()
DEFINE CELL  height '33' width '90' aling middle center of ohtm
set font color "#ffff80" of ohtm
LINK "http://sourceforge.net/projects/harbour-project/" ;
      IMAGE  "images/sflogo.png" ;
      border 0 Target "_top"  OF oHtm
set font color "black" of ohtm
oHtm:EndTableCell()
DEFINE CELL WIDTH "474" HEIGHT 151 ROWSPAN 2 TOP of ohtm
dEFINE TABLE BGCOLOR "#66ccff" height '143' width '494' border 2;
          COLORDARK "#66ccff" borderColor "#ffffff";
          COLORLIGHT "#66ccff"       of oHtm
ohtm:qqout("<TBODY>")
ohtm:newTableRow()
DEFINE CELL HEIGHT 17 WIDTH '95' ;
          COLORDARK "#808080"       ;
          COLORLIGHT "#ffffff"      ;          
 nowrap ALING middle of ohtm
//start font color "#000000" size 2 of ohtm
SAY "Home" ;
     TYPE '<B>'  color "#000000" STYLE "text-decoration: none" size  2  OF OHTM
ohtm:endtablecell()
DEFINE CELL width "71" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm" ;
    TEXT "Download" FONTCOLOR "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
    ohtm:EndTableCell()
DEFINE CELL width "85" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/links.htm" ;
    TEXT "Links" FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM
ohtm:EndTableCell()
DEFINE CELL width "84" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/mailinglist.htm" ;
    TEXT 'Mailing List' FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endTableCell()
DEFINE CELL width "123" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?http://www.hagbard.demon.co.uk/harbour/harbour.html" ;
    TEXT 'FAQ' FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endtablecell()
ohtm:EndTableRow()
oHtm:NewTableRow()
DEFINE CELL width "84" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;
           nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/functions.htm";
    TEXT  'Function List' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM

ohtm:Endtablecell()
DEFINE CELL width "71" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/crew.htm";
    TEXT  'Crew List' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM
ohtm:endTableCell()

DEFINE CELL width "85" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/art.htm";
    TEXT 'Harbour Art' FONTcolor "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
ohtm:endTableCell()

DEFINE CELL width "84" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/3rdparty.htm";
    TEXT '3rd Party' FONTcolor "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
ohtm:endTableCell()
DEFINE CELL width "123" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik/hbdoc";
    TEXT 'Documentation' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endTableCell()
ohtm:endtablerow()
ohtm:newTableRow()
Define cell colorlight "#ffffff" aling middle colspan 5 color "#ffffff" colordark "#ffffff";
        width "482" height "71" borderColor "#ffffff"  of ohtm
Image "images/theharbourproject2.gif" height "49" size 332 of ohtm
ohtm:endTableCell()
ohtm:endtablerow()
ohtm:newTableRow()
Define cell colorlight "#ffffff" aling middle colspan "5" color "#ffffff" colordark "#ffffff";
        width "482" height "25" borderColor "#ffffff" center of ohtm
oHtm:qqOut("<H3 align=center>")
LINK "funclist.exe?REDIRECT&http://www.harbour-project.org/download.htm";
    TEXT 'Download latest source code from CVS here' FONTcolor "#000000" BOLD OF OHTM
oHtm:qqOut("</H3>")
ohtm:endTableCell()
ohtm:endtablerow()

oHtm:qqOut("</TBODY>");ohtm:endtable()
ohtm:endTableCell()
ohtm:endtablerow()
ohtm:newTableRow()
define cell top width 90 height 114 of ohtm
define table bordercolor "#ffffff" height "129" colordark "#66ccff" width "100" bgcolor "#66ccff" colorlight "#66ccff" border 1 of ohtm
oHtm:qqOut("<TBODY>")
    ohtm:newTableRow()
    define cell colorlight "#808080" aling middle width "100%" height "15" colordark "#ffffff" of ohtm
    Link "funclist.exe?REDIRECT&http://www.conex.com.br/user/culik" TEXT "In Portugues" Fontcolor "#ffffff" target "_top" STYLE "TEXT-DECORATION: none" size 2 BOLD of ohtm
ohtm:endTableCell()
ohtm:endtablerow()
    ohtm:newTableRow()
    define cell colorlight "#808080" aling middle width "100%" height "15" colordark "#ffffff" of ohtm
oHtm:qqout("<P align=center>")
    Link "funclist.exe?REDIRECT&http://www.geocities.com/SiliconValley/Board/5300/" TEXT "In Spanish" Fontcolor "#ffffff" target "_top" STYLE "TEXT-DECORATION: none"  size 2 BOLD of ohtm
oHtm:qqout("</P>")
ohtm:endTableCell()
ohtm:endtablerow()
    ohtm:newTableRow()
    define cell colorlight "#808080" aling middle width "100%" height "15" colordark "#ffffff" of ohtm
    Link "funclist.exe?REDIRECT&http://www.harbour.pl.eu.org/" TEXT "In Polish" Fontcolor "#ffffff" target "_top" STYLE "TEXT-DECORATION: none" size 2   BOLD of ohtm
ohtm:endTableCell()
ohtm:endtablerow()
    ohtm:newTableRow()
    oHtm:FontFace:=nil
    oHtm:FontSize:=nil
    oHtm:Fontcolor:=nil
    define cell colorlight "#808080" aling middle width "100%" height "15" colordark "#ffffff"  of ohtm
    Link "funclist.exe?REDIRECT&https://sourceforge.net/bugs/?group_id=681" TEXT "Report<BR>bugs here" Fontcolor "#000080" target "_top" BOLD of ohtm
    Set font "" of ohtm
ohtm:endTableCell()
ohtm:endtablerow()
oHtm:qqOut("</TBODY>");ohtm:endtable()
ohtm:endTableCell()
ohtm:endtablerow()
oHtm:qqOut("</TBODY>");ohtm:endtable()

return nil
function  NUMTRIM( nNum )
Local c:=   STR( nNum )
Local y
y:=ltrim(c)
return y
