#include "website.ch"


//@@@ Statics

STATIC scQuery, soIni, scCmd



//
PROC MAIN( cCmd, cRecno )  // --> CMD line params. passed by server
LOCAL oCgi, aCmd, cQuery

SET DATE BRITISH
SET DATE FORMAT TO "dd/mm/yyyy"

IF cCmd == NIL
   cCmd := ""
ENDIF

IF "%" $ cCmd
   cCmd := DecodeURL( cCmd )
   aCmd := listAsArray( cCmd, " ")
   cCmd := aCmd[1]
   IF LEN( aCmd ) > 1
      cRecno := aCmd[2]
   ENDIF
ENDIF

scCmd := cCmd


IF "POST" $ UPPER(GETENV("REQUEST_METHOD"))
      oCgi   := oCGI():New()
      cQuery := UPPER(oCgi:query_String)          // just in case...
ELSE
      oCgi   := oCGI():New()
      cQuery := UPPER(GETENV("QUERY_STRING"))
ENDIF

scQuery := cQuery
soIni := oIni():New("website.ini")
soIni:read()
soIni:close()

//
//  simple redirection based on command line arguments.
//  Each of the following routines produces stand alone HTML/CGI output
//
//

IF "GUEST" $ cCmd
    GUESTPAGE(oCgi)
ELSEIF "TESTTA" $cCmd
    TestTa(oCgi)
ELSE
    BlankPage()
ENDIF

RETURN

PROCEDURE GUESTPAGE(oCgi)
LOCAL oHtm
DEFINE CGI ;
       TITLE "Redirection" ;
       ONLOAD "window.open('/cgi-bin/guestbook1.exe?BLDPAGE','Mywin','height=600,width=600');" ;
       BGCOLOR "white" ;
       OF oHtm
oHtm:WriteLN("<P>")
oHtm:WriteLN("If you are online you will be redirected to <b><i>Harbour Guest Page</b></i>")
oHtm:WriteLN("Please wait...")
oHtm:WriteLN("Redirect.exe Create with "+VERSION()+" and HTMLLIB")
oHtm:WriteLN("</P>")
oHtm:CGIClose()
RETURN

PROCEDURE BlankPage( oCgi)
LOCAL oHtm

DEFINE CGI ;
       BGIMAGE (COMMON_BGIMAGE) ;
       BGCOLOR (COMMON_BGCOLOR) ;
       TITLE "ACTION Error !!!" ;
       OF oHtm

oHtm:SetTextColor("black")
Start Font "VERDANA" SIZE 3 OF oHtm
oHtm:Setcenter( .T. )

oHtm:WriteLN("<br>")
oHtm:WriteLN("<b><u>ERROR !!!</u></b>")
oHtm:WriteLN("<br>")
   oHtm:WriteLN("Please specify an appropriate action...")


oHtm:WriteLN("<br><br><center>")
oHtm:WriteLN("<form>")
oHtm:WriteLN("<input type=button value='  Go Back  ' "+;
                    "onClick='history.back();return true;'>")
oHtm:WriteLN("</form>")
oHtm:WriteLN("<br><br></center>")


oHtm:cgiClose()

RETURN

PROC testta(ocgi)
LOCAL oHtm
DEFINE CGI TITLE 'TESTTA' bgcolor "white" of oHtm
SET FONT "" of ohtm
DEFINE TABLE BGCOLOR "#66ccff" border  0 WIDTH '600' CENTER of ohtm
ohtm:qqout("<TBODY>")
ohtm:newTableRow()
DEFINE CELL   height 1 width '90' aling middle center of ohtm
//Start font COLOR "#ffff80" OF ohtm
LINK "http://www.winfakt.com/harbour-project/default.htm" ;
      IMAGE  "../images/hrbbtn.gif" ;
      border 0 height '43'  width '99' Target "_top"  OF oHtm
//End font of ohtm 
ohtm:EndTableCell()
DEFINE CELL HEIGHT 1 WIDTH  '474' top OF OHTM
DEFINE TABLE BORDER 2 BGCOLOR "#66ccff" ;
          COLORDARK "#66ccff"       ;
          COLORLIGHT "#66ccff"      ;          
          BORDERCOLOR "#ffffff" of ohtm                        
ohtm:qqout("<TBODY>")
ohtm:newTableRow()
DEFINE CELL HEIGHT 1 WIDTH '95' ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
//start font color "#000000" size 2 of ohtm
LINK "http://www.winfakt.com/harbour-project/default.htm" ;
      Text "Home" FONTCOLOR "#000000#" SIZE 2 STYLE "TEXT-DECORATION: none"  BOLD of ohtm
ohtm:endtablecell()
DEFINE CELL width "71" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.winfakt.com/harbour-project/download.htm" ;
    TEXT "Download" FONTCOLOR "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
    ohtm:EndTableCell()
DEFINE CELL width "85" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.winfakt.com/harbour-project/links.htm" ;
    TEXT "Links" FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM
ohtm:EndTableCell()
DEFINE CELL width "84" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.winfakt.com/harbour-project/mailinglist.htm" ;
    TEXT 'Mailing List' FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endTableCell()
DEFINE CELL width "123" height 1 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.hagbard.demon.co.uk/harbour/harbour.html" ;
    TEXT 'FAQ' FONTCOLOR "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endtablecell()
ohtm:EndTableRow()
oHtm:NewTableRow()
DEFINE CELL width "84" height 15 ;
          COLORDARK "#808080"       ;
          COLORLIGHT "#ffffff"      ;
           nowrap ALING middle of ohtm
SAY "Function List" ;
     TYPE '<B>'  color "#000000" STYLE "text-decoration: none" size  2  OF OHTM
ohtm:Endtablecell()
DEFINE CELL width "71" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.winfakt.com/harbour-project/crew.htm";
    TEXT  'Crew List' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD  OF OHTM
ohtm:endTableCell()

DEFINE CELL width "85" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.winfakt.com/harbour-project/art.htm";
    TEXT 'Harbour Art' FONTcolor "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
ohtm:endTableCell()

DEFINE CELL width "84" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.winfakt.com/harbour-project/3rdparty.htm";
    TEXT '3rd Party' FONTcolor "#000000" STYLE "text-decoration: none" size  2  BOLD OF OHTM
ohtm:endTableCell()
DEFINE CELL width "123" height 15 ;
          COLORDARK "#ffffff"       ;
          COLORLIGHT "#808080"      ;          
 nowrap ALING middle of ohtm
LINK "http://www.conex.com.br/user/culik/hbdoc";
    TEXT 'Documentation' FONTcolor "#000000" STYLE "text-decoration: none" size  2 BOLD OF OHTM
ohtm:endTableCell()

ohtm:endtablerow();ohtm:qqout("</TBODY>");ohtm:endTable();ohtm:EndTableRow();ohtm:qqout("</TBODY>");ohtm:endtable()



ohtm:Paragraph()
SAY "Below is a list of all Harbour "+;
"functions in the RTL and their current state. This list is "+;
"updated as changes are made to the library. This list is based on "+;
"Clipper 5.2. The legend is as follows:" SIZE 2 OF OHTM
ohtm:Paragraph(.F.)
ohtm:Paragraph()
SAY  "<strong>Ready</strong><br>" +;
"No more work needed on this function"  size 2 of ohtm
ohtm:Paragraph(.F.)
ohtm:Paragraph()
SAY "<strong>Started</strong><br>" +;
"This function needs some work but will provide basic " +;
"functionality and can be used for testing." size 2 of ohtm
ohtm:Paragraph(.F.)
ohtm:Paragraph()
SAY "<strong>Not Started</strong><br>"+;
"This function has yet to be written"  size 2 of ohtm
ohtm:Paragraph(.F.)
ohtm:setcenter(.t.)
DEFINE TABLE  BGCOLOR CLR_WHITE border 1 width "500"  CELLPADDING 2 CELLSPACING 1 CENTER        of oHtm
oHtm:newTableRow()
DEFINE CELL color "#3000FF" WIDTH "50%"  SIZE 2  FONTCOLOR  "#ffff00"  ROWSPAN 2 of oHtm
oHtm:qqout('<center><b>Function</b>')
oHtm:EndTableCell()
DEFINE CELL color "#3000FF" WIDTH "50%"  SIZE 2  FONTCOLOR  "#ffff00"  COLSPAN 3  of oHtm
oHtm:qqout('<center><b>Status</b>')
oHtm:EndTableCell()
oHtm:EndTableRow()
oHtm:newTableRow()  
DEFINE CELL  color "#3000FF" WIDTH "16%"  SIZE 2  FONTCOLOR  "#ffff00"    of oHtm     
oHtm:qqout("<center><b>Ready</b>");oHtm:EndTableCell() 

DEFINE CELL  color "#3000FF" WIDTH "16%"  SIZE 2  FONTCOLOR  "#ffff00"     of oHtm     
oHtm:qqout("<center><b>Stated</b>");oHtm:EndTableCell()

DEFINE CELL  color "#3000FF" WIDTH "16%"  SIZE 2  FONTCOLOR  "#ffff00"     of oHtm     
oHtm:qqout("<center><b>Not Stated</b>");oHtm:EndTableCell() ; oHtm:EndTableRow()
oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("AADD");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ABS");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ACHOICE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ACLONE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ACOPY");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ADEL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ADIR");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("AEVAL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("AFIELDS");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("AFILL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("AINS");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ALERT");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ALIAS");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ALLTRIM");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ALTD");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ARRAY");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ASC");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ASCAN");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ASIZE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ASORT");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("AT");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("ATAIL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("BIN2I");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("BIN2L");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()


oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("BIN2W");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("BOF");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("BREAK");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("BROWSE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("CDOW");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("CHR");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("CMONTH");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("COL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("COLORSELECT");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("CTOD");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("CURDIR");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DATE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DAY");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBAPPEND");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCLEARFILTER");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCLEARINDEX");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCLEARRELATION");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCLOSEALL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCLOSEAREA");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCOMMIT");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCOMMITALL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCREATE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBCREATEIND");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()
oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBDELETE");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBEDIT");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBEVAL");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBF");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBFILTER");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()
Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:NewTableRow()
Define cell width "50%" size 2 of ohtm
oHtm:qqout("DBGOBOTTOM");oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('<CENTER><IMG SRC="../images/purple-m.gif">');oHtm:EndTableCell()

Define cell Width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell()

Define cell width "16%" size 2 of ohtm
oHtm:qqout('&nbsp');oHtm:EndTableCell();oHtm:EndTableRow()

oHtm:EndTable()
ohtm:setcenter(.f.)
oHtm:cgiClose()
return 
